// This is part of the gen_ir WinLIRC Winamp Plugin DLL.
// Copyright (c) 1998 Jim Paris

// AddDlg.cpp : implementation file
//

#include "stdafx.h"
#include "gen_ir.h"
#include "EditDlg.h"
#include "config.h"
#include "gen_ir.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAddDlg dialog


CEditDlg::CEditDlg(Cconfig *nconf, int action, CWnd* pParent /*=NULL*/)
	: CDialog(CEditDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAddDlg)
	m_id = _T("");
	//}}AFX_DATA_INIT
   m_action = action;
	conf=nconf;
}


void CEditDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAddDlg)
	DDX_Control(pDX, IDC_ACTION, m_act);
	DDX_Text(pDX, IDC_ID, m_id);
	DDV_MaxChars(pDX, m_id, 64);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEditDlg, CDialog)
	//{{AFX_MSG_MAP(CAddDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAddDlg message handlers

void CEditDlg::OnOK() 
{
	UpdateData();

	if(m_id.IsEmpty())
	{
		MessageBox("You need to enter a button ID.");
		return;
	}
	
	int index=m_act.GetCurSel();
	if(index==CB_ERR)
	{
		MessageBox("You need to select an action.");
		return;
	}
	
	conf->our_buttons.Add(m_id);
	conf->our_actions.Add(m_act.GetItemData(index));
	
	CDialog::OnOK();
}

BOOL CEditDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	int index;

	for(int i=0;i<TOTAL_ACTIONS;i++)
	{
		index=m_act.AddString(acts[i].name);
		if(index>=0)
			m_act.SetItemData(index,i);
	}

	for(i=0;i<TOTAL_ACTIONS;i++)
   {
      index = m_act.GetItemData(i);
      if(index == m_action)
      {
        m_act.SetCurSel(i);
      }
   }
	GotoDlgCtrl(GetDlgItem(IDC_ID));
	
	return FALSE; // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
