// gen_ir.h : main header file for the GEN_IR DLL
//

#if !defined(AFX_GEN_IR_H__D55A1691_CC1B_11D2_8C7F_004005637418__INCLUDED_)
#define AFX_GEN_IR_H__D55A1691_CC1B_11D2_8C7F_004005637418__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// main symbols
#include "mysock.h"
#include "winamp.h"

/*****************/
/* ACTIONS below */
/*****************/
const WM_AIMP_COMMAND = WM_USER + 117;
const struct act {
	char *name;
	bool repeatable;
	int count;
	UINT message;
	WPARAM wparam;
	LPARAM lparam;
};

#define CONFIG_FILE			 "gen_ir.ini" 

#define TOTAL_ACTIONS 58
const act acts[TOTAL_ACTIONS] = {
	{ "Fast forward",				true,	1,	WM_COMMAND, WINAMP_FF,					0	},
	{ "Rewind",      				true,	1,	WM_COMMAND, WINAMP_REW,					0	},
	{ "Volume up",					true,	1,	WM_COMMAND,	WINAMP_VOLUMEUP,			0	},
	{ "Volume down",				true,	1,	WM_COMMAND,	WINAMP_VOLUMEDOWN,			0	},
	{ "Volume up 10",				true,	5,	WM_COMMAND,	WINAMP_VOLUMEUP,			0	},
	{ "Volume down 10",				true,	5,	WM_COMMAND,	WINAMP_VOLUMEDOWN,			0	},
	{ "Toggle always on top",		false,	1,	WM_COMMAND,	WINAMP_AOT_TOGGLE,			0	},
	{ "Toggle repeat mode",			false,	1,	WM_COMMAND,	WINAMP_REPEAT_TOGGLE,		0	},
	{ "Toggle shuffle mode",		false,	1,	WM_COMMAND,	WINAMP_SHUFFLE_TOGGLE,		0	},
	{ "Display: elapsed time",		false,	1,	WM_COMMAND,	WINAMP_DISPLAYELAPSED,		0	},
	{ "Display: remaining time",	false,	1,	WM_COMMAND,	WINAMP_DISPLAYREMAIN,		0	},
	{ "Stop after current track",	false,	1,	WM_COMMAND,	WINAMP_STOPAFTCURTRK,		0	},
	{ "Open files",					false,	1,	WM_AIMP_COMMAND,	3,					0	},
	{ "Open directory",				false,	1,	WM_AIMP_COMMAND,	3,					1	},
	{ "About",						false,	1,	WM_AIMP_COMMAND,	3,					2	},
	{ "Sleep timer",				false,	1,	WM_AIMP_COMMAND,	3,					3	},
	{ "Utils Audio Converter",		false,	1,	WM_AIMP_COMMAND,	3,					4	},
	{ "Utils Sound Recoder",		false,	1,	WM_AIMP_COMMAND,	3,					5	},
	{ "Utils Tag Editor",			false,	1,	WM_AIMP_COMMAND,	3,					6	},
	{ "Utils CD Grabber",			false,	1,	WM_AIMP_COMMAND,	3,					7	},
	{ "Options",					false,	1,	WM_AIMP_COMMAND,	3,					8	},
	{ "Plugins",					false,	1,	WM_AIMP_COMMAND,	3,					9	},
	{ "Quit Aimp",					false,	1,	WM_AIMP_COMMAND,	3,					10	},
	{ "Next visualization",			false,	1,	WM_AIMP_COMMAND,	3,					11	},
	{ "Previous visualization",		false,	1,	WM_AIMP_COMMAND,	3,					12	},
	{ "Toggle equalizer",			false,	1,	WM_AIMP_COMMAND,	3,					13	},
	{ "Minimize to tray",			false,	1,	WM_AIMP_COMMAND,	3,					14	},
	{ "Play",						false,	1,	WM_AIMP_COMMAND,	3,					15	},
	{ "Pause",						false,	1,	WM_AIMP_COMMAND,	3,					16	},
	{ "Stop",						false,	1,	WM_AIMP_COMMAND,	3,					17	},
	{ "Next track",					false,	1,	WM_AIMP_COMMAND,	3,					18	},
	{ "Previous track",				false,	1,	WM_AIMP_COMMAND,	3,					19	},
	{ "Add files",					false,	1,	WM_AIMP_COMMAND,	3,					20	},
	{ "Add directory",				false,	1,	WM_AIMP_COMMAND,	3,					21	},
	{ "Add playlist",				false,	1,	WM_AIMP_COMMAND,	3,					22	},
	{ "Add url",					false,	1,	WM_AIMP_COMMAND,	3,					23	},
	{ "Delete files",				false,	1,	WM_AIMP_COMMAND,	3,					24	},
	{ "Delete bad files",			false,	1,	WM_AIMP_COMMAND,	3,					25	},
	{ "Delete from hdd",			false,	1,	WM_AIMP_COMMAND,	3,					26	},
	{ "Delete off files",			false,	1,	WM_AIMP_COMMAND,	3,					27	},
	{ "Delete off files from hdd",	false,	1,	WM_AIMP_COMMAND,	3,					28	},
	{ "Rescan playlist",			false,	1,	WM_AIMP_COMMAND,	3,					29	},
	{ "Show curfile",				false,	1,	WM_AIMP_COMMAND,	3,					30	},
	{ "Sort invert",				false,	1,	WM_AIMP_COMMAND,	3,					31	},
	{ "Sort random",				false,	1,	WM_AIMP_COMMAND,	3,					32	},
	{ "Sort title",					false,	1,	WM_AIMP_COMMAND,	3,					33	},
	{ "Sort artist",				false,	1,	WM_AIMP_COMMAND,	3,					34	},
	{ "Sort folder",				false,	1,	WM_AIMP_COMMAND,	3,					35	},
	{ "Sort length",				false,	1,	WM_AIMP_COMMAND,	3,					36	},
	{ "Sort rating",				false,	1,	WM_AIMP_COMMAND,	3,					37	},
	{ "Search",						false,	1,	WM_AIMP_COMMAND,	3,					38	},
	{ "Open playlist",				false,	1,	WM_AIMP_COMMAND,	3,					39	},
	{ "Save playlist",				false,	1,	WM_AIMP_COMMAND,	3,					40	},
	{ "Play last",					false,	1,	WM_AIMP_COMMAND,	3,					41	},
	{ "Turn off selected",			false,	1,	WM_AIMP_COMMAND,	3,					42	},
	{ "Turn on selected",			false,	1,	WM_AIMP_COMMAND,	3,					43	},
	{ "Add to bookmark",			false,	1,	WM_AIMP_COMMAND,	3,					44	},
	{ "Edit bookmarks",				false,	1,	WM_AIMP_COMMAND,	3,					45	},
};

/*****************/
/* ACTIONS above */
/*****************/





typedef struct {
	int version;
	char *description;
	int (*init)();
	void (*config)();
	void (*quit)();
	HWND hwndParent;
	HINSTANCE hDllInstance;
} winampGeneralPurposePlugin;

/* Data structure version */
#define DS_VERSION 0x10

/* Winamp functions and arrays */
extern winampGeneralPurposePlugin *gen_plugins[256];
typedef winampGeneralPurposePlugin * (*winampGeneralPurposePluginGetter)();


/////////////////////////////////////////////////////////////////////////////
// CGen_irApp
// See gen_ir.cpp for the implementation of this class
//

class CGen_irApp : public CWinApp
{
public:
	CGen_irApp();

	int winampInit(void);
	void winampConfig(void);
	void winampQuit(void);

	bool ReadConfig(void);
	void WriteConfig(void);

	void HandleButton(const char *name, unsigned int repeat);

	bool initialized;
	bool connected;

	CStringArray buttons;
	CDWordArray actions;
   char   g_szIniFile[512];

private:

	CMySocket client;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGen_irApp)
	public:
	virtual BOOL InitInstance();
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CGen_irApp)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GEN_IR_H__D55A1691_CC1B_11D2_8C7F_004005637418__INCLUDED_)
